﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Sales
{
    public class Canceled : IOrderState
    {
        private SalesOrder salesOrder;

        public Canceled(SalesOrder salesOrder)
        {
            // TODO: Complete member initialization
            this.salesOrder = salesOrder;
        }
        public void AddOrderLine()
        {
            throw new ChangeStateException("Order was canceled");
        }

        public void Register()
        {
            throw new ChangeStateException("Order was canceled");
        }

        public void Grant()
        {
            throw new ChangeStateException("Order was canceled");
        }

        public void Ship()
        {
            throw new ChangeStateException("Order was canceled");
        }

        public void Invoice()
        {
            throw new ChangeStateException("Order was canceled");
        }

        public void Cancel()
        {
            throw new ChangeStateException("Order was already canceled");
        }
    }
}
