﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Sales
{
    public class Shipped : IOrderState
    {
        private SalesOrder salesOrder;

        public Shipped(SalesOrder salesOrder)
        {
            // TODO: Complete member initialization
            this.salesOrder = salesOrder;
        }
        public void AddOrderLine()
        {
            throw new ChangeStateException("Shipping already!");
        }

        public void Register()
        {
            throw new ChangeStateException("Registered already!");
        }

        public void Grant()
        {
            throw new ChangeStateException("Granted already!");
        }

        public void Ship()
        {
            throw new ChangeStateException("Shipping already!");
        }

        public void Invoice()
        {
            this.salesOrder._Invoice();
            this.salesOrder.currentState = new Invoiced(this.salesOrder);
        }

        public void Cancel()
        {
            this.salesOrder._Cancel();
            this.salesOrder.currentState = new Canceled(this.salesOrder);
        }
    }
}
