﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TreeRenderingWithVisitor
{
    public interface ITree
    {
        string Id { get; set;}
        string Name { get; set; }
        IList<ITree> Children { get; }
        void AddChild(ITree node);
        string Render(IRenderer renderer);
    }
}
